# consultUnbinding

`POST /aps/api/v1/authorizations/consultUnbinding`

The Mobile Payment Provider (MPP) uses the **consultUnbinding** API to consult whether the auth client (usually the merchant) allows an access token to be canceled from the MPP side.

Usually, the MPP calls the **consultUnbinding** API when the MPP user wants to unbind his/her MPP account with the related auth client account. 

**Note**: In the following sections, the MPP is also known as PSP. For example, _pspId_ refers to the ID that identifies an MPP. 

## Structure

A message consists of a header and body. The following sections are focused on the body structure. For the header structure, see:

-   [Request header](api_overview#3mLq0)
-   [Response header](api_overview#YdmVS)

> **Note**:
>
> 1.  Set the data type of each parameter (except array) as String. This means that you must use double quotation marks (" ") to enclose the parameter value. Examples:
>
> -   If the data type of a parameter is Integer and its value is 20, set it as "20".
> -   If the data type of a parameter is Boolean and its value is `true`, set it as "true".
>
> 2.  For optional parameters that are not required in your case, you can take one of the following actions:
>
> -   Exclude the parameters from the request body.
> -   Set the parameter values as `null` (without the double quotation marks).
>
> Do NOT leave the optional parameters empty by setting their values as `""`; otherwise, an error might occur.

## Request parameters

#### authClientId (String, REQUIRED)

The unique ID that is assigned by the Acquiring Service Provider (ACQP) to identify the auth client, which is usually the merchant.

More information:

- Maximum length: 64 characters

#### referenceMerchantId (String, REQUIRED)

The unique ID that is assigned by the ACQP to identify a merchant.

More information:

- Maximum length: 32 characters

#### accessToken (String, REQUIRED)

The token that is used to access the MPP user's resources.

More information:

- Maximum length: 128 characters

## Response parameters

#### result (Result, REQUIRED)

The result of the consulting. For more information about how to handle the result of the **consultUnbinding** API, see _How to handle the result_.

##### resultCode (String, REQUIRED)

The result code that indicates the detailed processing result.

More information:

- Maximum length: 64 characters

##### resultStatus (String, REQUIRED)

The result status that indicates the processing result. Valid values are:

-   `S`: Successful
-   `F`: Failed
-   `U`: Unknown

##### resultMessage (String)

The result message that describes the result code in detail.

More information:

- Maximum length: 256 characters

#### acquirerId (String)

The unique ID that is assigned by Alipay+ to identify an ACQP

This parameter is returned by Alipay+ if the value of the _result_._resultCode_ parameter is `SUCCESS`.

More information:

- Maximum length: 64 characters

#### pspId (String)

The unique ID that is assigned by Alipay+ to identify an MPP

This parameter is returned by Alipay+ if the value of the _result_._resultCode_ parameter is `SUCCESS`.

More information:

- Maximum length: 64 characters

#### allowUnbinding (Boolean)

This parameter indicates whether the auth client allows the access token to be revoked from the MPP side. Valid values are:

-   `true`: The auth client allows the access token to be revoked from the MPP side.
-   `false`: The auth client does not allow the access token to be revoked from the MPP side.

This parameter is returned by Alipay+ if the value of the _result_._resultCode_ parameter is `SUCCESS`.

#### refuseReason (String)

The reason that the account unbinding is refused.

This parameter is returned by Alipay+ if the ACQP does not allow the access token to be revoked from the MPP side.

More information:

- Maximum length: 256 characters

## More information

### How to handle the result

You might receive different results from Alipay+. Follow the instructions below to handle the result.

| result.resultStatus | result.resultCode                               | Consultation status            | Actions                                                                                                                                      |
|---------------------|------------------------------------------------|-------------------------------|----------------------------------------------------------------------------------------------------------------------------------------------|
| `S`                 | `SUCCESS`                                      | The API call succeeds and the consultation about unbinding is completed. | Retrieve the value of the *allowUnbinding* parameter to see whether the access token can be revoked from the MPP side.                        |
| `F`                 | Multiple possible values such as `ACCESS_DENIED`, `KEY_NOT_FOUND`, etc. | The API call fails, probably because of the system exception. | Take actions according to the error message in the *result.resultCode* parameter. If the problem persists, contact connect_support@service.alipay.com. |
| `U`                 | Multiple possible values such as `UNKNOWN_EXCEPTION`, `REQUEST_TRAFFIC_EXCEED_LIMIT`, etc. | Unknown exception, which might be caused by network timeout. | It is recommended that the MPP guides the user to reopen the Authorization Detail Page and reinitiate the account unbinding process.         |
| No result received  | No result received                             | It is possible that network issues occurred or Alipay+ did not respond.           | It is recommended that the user reopen the Authorization Detail Page and reinitiate the account unbinding process.                           |

## Result/Error codes

| Code | Value | Message | Further action |
| --- | --- | --- | --- |
| SUCCESS | S | Success | Retrieve the value of the allowUnbinding parameter to see whether the access token can be revoked from the MPP side. |
| ACCESS_DENIED | F | Access is denied. | It is recommended that you contact connect_support@service.alipay.com to troubleshoot the issue. |
| INVALID_CLIENT | F | The client is invalid. | It is recommended that you contact connect_support@service.alipay.com to troubleshoot the issue. |
| INVALID_SIGNATURE | F | The signature is invalid. | Check whether the public key, signed message, and signature algorithm are as expected. |
| KEY_NOT_FOUND | F | The key is not found. | It is recommended that you contact connect_support@service.alipay.com to troubleshoot the issue. |
| MEDIA_TYPE_NOT_ACCEPTABLE | F | The server does not implement the media type that is acceptable to the client. | Use a media type that is accepted by Alipay+. |
| METHOD_NOT_SUPPORTED | F | The server does not implement the requested HTTPS method. | Ensure the HTTP method is POST. |
| NO_INTERFACE_DEF | F | API is not defined. | Check whether the request URL is correct. Ensure that the endpoint of the called API is correct. |
| PARAM_ILLEGAL | F | Illegal parameters. For example, non-numeric input, invalid date. | Check whether the request parameters, including the header parameters and body parameters, are correct and valid. For more information about the parameters of each API, see the Structure section of the specific API reference topic. |
| PROCESS_FAIL | F | A general business failure occurred. Do not retry. | It is recommended that you contact connect_support@service.alipay.com to troubleshoot the issue. |
| REQUEST_TRAFFIC_EXCEED_LIMIT | U | The request traffic exceeds the limit. | Reduce the frequency of API calls. |
| UNKNOWN_EXCEPTION | U | An API call failed, which is caused by unknown reasons. | Try to recall the API. |

## Request

### ALIPAY, ALIPAY_HK, DANA, H5, DIRECT

```json
{
  "authClientId": "21888211212100",
  "referenceMerchantId": "21888211212101",
  "accessToken": "2810120412122ojsalksa000"
}
```

## Response

```json
{
  "result": {
    "resultCode": "SUCCESS",
    "resultStatus": "S",
    "resultMessage": "success"
  },
  "acquirerId": "1020000000000000001",
  "pspId": "1020000000000000002",
  "allowUnbinding": "false",
  "refuseReason": "merchant not allow unbinding"
}
```